package at.ac.uibk.gitsearch.repository;

import at.ac.uibk.gitsearch.domain.WatchListEntry;
import java.util.List;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

/**
 * Spring Data  repository for the WatchListEntry entity.
 */
@Repository
public interface WatchListEntryRepository extends JpaRepository<WatchListEntry, Long> {
    @Query("SELECT wle FROM WatchListEntry wle WHERE wle.watchlist.id=:watchListId")
    public List<WatchListEntry> getEntriesByWatchlist(@Param("watchListId") Long watchListId);

    @Query("SELECT wle FROM WatchListEntry wle WHERE wle.watchlist.id=:watchListId AND wle.exerciseId=:exerciseId ")
    public List<WatchListEntry> getEntriesByWatchlistAndExerciseId(
        @Param("watchListId") Long watchListId,
        @Param("exerciseId") String exerciseId
    );
}
